#ifndef __ACTIVE_CONNECTION_H__
#define __ACTIVE_CONNECTION_H__

#include <es_sock.h>

class MSockReadObserver;

class CSocketRead : public CActive {


    CSocketRead(RSocket& aSocket, MSockReadObserver* aObserver, TInt aXfrLen = 1);
    void ConstructL();

    RSocket&           iSocket;
    TBuf8<256>         iBuffer;
    MSockReadObserver* iObserver;
    TSockXfrLength     iLen;

    void DoCancel();

    void RunL();

public:

    static CSocketRead* NewL(RSocket& aSocket, MSockReadObserver* aObserver);
    static CSocketRead* NewLC(RSocket& aSocket, MSockReadObserver* aObserver);

    void Receive();

    virtual ~CSocketRead();
};



class CSocketWrite : public CActive {

    CSocketWrite(RSocket& aSocket);
    void ConstructL();

    RSocket&   iSocket;

    void DoCancel();
    void RunL();
    void IssueWrite();

    class CRequest : public CBase {

	HBufC8*	    iBuffer;

	void ConstructL(const TDesC8& aBuf);
    public:
	TSglQueLink ilink;

	static CRequest* NewLC(const TDesC8& aBuf);
	static CRequest* NewL(const TDesC8& aBuf);
	
	virtual ~CRequest();

	const TDesC8& Buffer() const { return *iBuffer; }
    };

    TSglQue<CRequest> iRequests;

public:

    static CSocketWrite* NewL(RSocket& aSocket);
    static CSocketWrite* NewLC(RSocket& aSocket);

    void WriteL(const TDesC8& aBuf);

    virtual ~CSocketWrite();
};


#endif // __ACTIVE_CONNECTION_H__