//
// CHelpTask
//

// simple class to implement help files...


#include <w32std.h>
#include <eikapp.h>

#ifdef _MSC_VER
#pragma warning(disable:4245) // signed/unsigned mismatch
#endif

#include <bautils.h>
#ifdef _MSC_VER
#pragma warning(default:4245) // signed/unsigned mismatch
#endif

#include <apgtask.h>
#include <apacmdln.h>
#include <eikdll.h>
#include <eikenv.h>
#include <eikproc.h>

#include "Helptask.h"


//
// NewLC
//
CHelpTask* CHelpTask::NewLC(const TFileName& aEikAppPath) {

    CHelpTask* self = new (ELeave) CHelpTask();
    CleanupStack::PushL(self);
    self->ConstructL(aEikAppPath);

    return self;
}


void CHelpTask::ConstructL(const TFileName& aEikAppPath) {

    iTask = new (ELeave) TApaTask(CEikonEnv::Static()->WsSession());

    TParse parse;
    parse.Set(_L(".hlp"), &aEikAppPath, NULL);
   
    iHelpFileName = parse.FullName();
    BaflUtils::NearestLanguageFile(CEikonEnv::Static()->Process()->FsSession(),iHelpFileName);

    // we dont attempt to find already launched instances of the help,
    // so every app has its own open copy of help...
    iHelpAppLaunched = EFalse;
}


CHelpTask::~CHelpTask() {
    Close();

    delete iTask;
}


void CHelpTask::DisplayL() {

    if (LocateHelpTask(*iTask)) {
	iTask->BringToForeground();
    }
    else {
	CApaCommandLine* cmdLine=CApaCommandLine::NewLC();
	cmdLine->SetLibraryNameL(_L("z:\\System\\Apps\\Data\\data.app"));
	cmdLine->SetCommandL(EApaCommandOpen);
	cmdLine->SetDocumentNameL(iHelpFileName); 

	iHelpAppThreadId = EikDll::StartAppL(*cmdLine);
	
	CleanupStack::PopAndDestroy(); // cmdLine
	
	iHelpAppLaunched=ETrue;
    }
}


void CHelpTask::Close()
{
    if (LocateHelpTask(*iTask)) {
	iTask->EndTask();
    }

    // leave iHelpAppLaunched set, in case the endtask fails
}


TBool CHelpTask::LocateHelpTask(TApaTask& aTask) {
    if (iHelpAppLaunched) {	// see if we can find it.
	TInt wgId = CEikonEnv::Static()->WsSession().FindWindowGroupIdentifier(0, iHelpAppThreadId);

	aTask.SetWgId(wgId);
	if (aTask.Exists()) {
	    return ETrue;
	}
	else {
	    iHelpAppLaunched = EFalse;
	}
    }

    return EFalse;
}


